import { Component } from '@angular/core';
import { FormControl, Validators } from '@angular/forms';

const EMAIL_REGEX = /^[a-zA-Z0-9.!#$%&’*+/=?^_`{|}~-]+@[a-zA-Z0-9-]+(?:\.[a-zA-Z0-9-]+)*$/;

/**
 * @title Input Errors
 */
@Component({
    selector   : 'input-errors-example',
    templateUrl: 'input-errors-example.html',
    styleUrls  : ['input-errors-example.css']
})
export class InputErrorsExample
{

    emailFormControl = new FormControl('', [
        Validators.required,
        Validators.pattern(EMAIL_REGEX)
    ]);

}
